% !TeX root = ./main.tex
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{lmodern}
\usepackage{amsmath, amssymb}

\usepackage[printonlyused,withpage]{acronym}
\usepackage{comment}
\usepackage{pifont}
\usepackage[inline]{enumitem}
\usepackage[c]{esvect}
\usepackage{graphicx}
\usepackage[cache=false]{minted}
\usepackage{multirow}
\usepackage{nameref}
\usepackage[numbers]{natbib}
\usepackage{setspace}
\usepackage[list=true]{subcaption}
\usepackage{tocloft}
\usepackage{tabularx}
\usepackage{tkz-euclide}
\usepackage{verbatim}
\usepackage{xcolor}

\usepackage[hidelinks]{hyperref}
\usepackage{cleveref}

% --- settings ---

% tables
\setlength{\tabcolsep}{1ex}

% renew listing environment
\newenvironment{Listing}[1][htbp]{%
  \captionsetup{aboveskip=-.2\normalbaselineskip} % just reduce above cap space
  \begin{listing}}{\end{listing}}

% structure
\setcounter{secnumdepth}{3}

% --- package settings ---

% asmmath
\renewcommand*{\vec}[1]{\vv{#1}}
\renewcommand*{\arraystretch}{1.2}

% enumitem
\setlist{
  listparindent=\parindent,
  parsep=0pt
}

% minted
\usemintedstyle{friendly}
\renewcommand{\theFancyVerbLine}{\scriptsize\arabic{FancyVerbLine}}
\setminted{
  autogobble,
  fontsize=\small,
  frame=lines,
  framesep=1ex,
  linenos,
  numbersep=4pt
}

% natbib
\renewcommand{\bibname}{\refname}
\renewcommand{\bibsection}{\section*{\bibname}}

% pifont
\newcommand{\xmark}{\ding{55}}

% tkz-euclide
\usetkzobj{all}

%\includecomment{comment} % Uncomment to include comments

% tocloft
\tocloftpagestyle{empty}
\setlength{\cftaftertoctitleskip}{1em}
\setlength{\cftbeforetoctitleskip}{2em}
%% table of contents
\setcounter{tocdepth}{3}
\renewcommand{\cfttoctitlefont}{\Large\bfseries}
\setlength{\cftsecindent}{0em}
\setlength{\cftsecnumwidth}{1.2em}
\setlength{\cftsubsecindent}{\cftsecindent+\cftsecnumwidth}
\setlength{\cftsubsecnumwidth}{1em+\cftsecnumwidth}
\setlength{\cftsubsubsecindent}{\cftsubsecindent+\cftsubsecnumwidth}
\setlength{\cftsubsubsecnumwidth}{1em+\cftsubsecnumwidth}
%% list of figures (+ subcaption patch)
\makeatletter
\newlength{\cftbeforesubfigskip}
  \setlength{\cftbeforesubfigskip}{\z@ \@plus.2\p@}
\newlength{\cftsubfigindent}
\newlength{\cftsubfignumwidth}
\newcommand{\cftsubfigfont}{\normalfont}
\newcommand{\cftsubfigpresnum}{}
\newcommand{\cftsubfigaftersnum}{}
\newcommand{\cftsubfigaftersnumb}{}
\newcommand{\cftsubfigleader}{\normalfont\cftdotfill{\cftsubfigdotsep}}
\newcommand{\cftsubfigdotsep}{\cftdotsep}
\newcommand{\cftsubfigpagefont}{\normalfont}
\newcommand{\cftsubfigafterpnum}{}
\newcommand{\cftsubfigfillnum}[1]{%
  {\cftsubfigleader}\nobreak
  \hb@xt@\@pnumwidth{\hfil\cftsubfigpagefont #1}\cftsubfigafterpnum\par}
\renewcommand*{\l@subfigure}[2]{%
  \ifnum \c@lofdepth > \@ne
    \vskip \cftbeforesubfigskip
    {\leftskip \cftsubfigindent\relax
     \rightskip \@tocrmarg
     \parfillskip -\rightskip
     \parindent \cftsubfigindent\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima \cftsubfignumwidth\relax
     \let\@cftbsnum \cftsubfigpresnum
     \let\@cftasnum \cftsubfigaftersnum
     \let\@cftasnumb \cftsubfigaftersnumb
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
     {\cftsubfigfont #1}\nobreak
     \cftsubfigfillnum{#2}}
  \fi}
\makeatother
\setcounter{lofdepth}{2}
\renewcommand{\cftloftitlefont}{\cfttoctitlefont}
\setlength{\cftafterloftitleskip}{\cftaftertoctitleskip}
\setlength{\cftbeforeloftitleskip}{\cftbeforetoctitleskip}
\setlength{\cftfigindent}{\cftsecindent}
\setlength{\cftfignumwidth}{\cftsecnumwidth}
\setlength{\cftsubfigindent}{\cftsubsecindent}
\setlength{\cftsubfignumwidth}{\cftsecnumwidth}
%% list of listings
\makeatletter
\begingroup\let\newcounter\@gobble\let\setcounter\@gobbletwo
  \globaldefs\@ne \let\c@loldepth\@ne
  \newlistof{listings}{lol}{\listoflistingscaption}
\endgroup
\let\l@listing\l@listings
\makeatother
\newcommand{\listlistingsname}{\listoflistingscaption}
\renewcommand{\cftloltitlefont}{\cfttoctitlefont}
\setlength{\cftafterloltitleskip}{\cftaftertoctitleskip}
\setlength{\cftbeforeloltitleskip}{\cftbeforetoctitleskip}
\setlength{\cftlistingsnumwidth}{\cftsecnumwidth}
%% list of tables
\setcounter{lotdepth}{2}
\renewcommand{\cftlottitlefont}{\cfttoctitlefont}
\setlength{\cftafterlottitleskip}{\cftaftertoctitleskip}
\setlength{\cftbeforelottitleskip}{\cftbeforetoctitleskip}
\setlength{\cfttabindent}{\cftsecindent}
\setlength{\cfttabnumwidth}{\cftsecnumwidth}

% llncs
\titlerunning{Constraint-Based Programming}
\title{\the\titlerunning}
% If the paper title is too long for the running head, you can set
% an abbreviated paper title here
\author{Rui Ventura\inst{1}\orcidID{0000-0003-0607-2382}}
\authorrunning{V. Rui}
% First names are abbreviated in the running head.
% If there are more than two authors, 'et al.' is used.
\institute{Instituto Superior Técnico, Universidade de Lisboa\\
\email{rui.ventura@tecnico.ulisboa.pt}}
